---

- name: Verify
  hosts: all
  vars:
    moosefs_version: '3.0.112'
    moosefs:
      chunkservers:
        - ip: 127.0.0.1
          name: mfsmaster
          hdds_prod:
            - /mnt/mfschunks1
            - /mnt/mfschunks2
          hdds_spare:
            - /mnt/mfschunks3
    moosefs_mount: /shared/mfs
    moosefs_folders:
      - /shared/mfs/data
    moosefs_links:
      - data:
        src: /shared/mfs/data
        dest: /shared/data
  tasks:
    - name: Gathering service facts
      service_facts:
    # - name: show services
    #   debug:
    #     var: ansible_facts.services
    - name: check moosefs services (Debian)
      assert:
        that:
          - ansible_facts.services["moosefs-master"].state == "running"
          - ansible_facts.services["moosefs-cgiserv"].state == "running"
          - ansible_facts.services["moosefs-chunkserver"].state == "running"
      when: ansible_os_family == 'Debian'
    - name: check moosefs services (RedHat)
      assert:
        that:
          - ansible_facts.services["moosefs-master.service"].state == "running"
          - ansible_facts.services["moosefs-cgiserv.service"].state == "running"
          # yamllint disable-line rule:line-length
          - ansible_facts.services["moosefs-chunkserver.service"].state == "running"
      when: ansible_os_family == 'RedHat'
    - name: Wait for metaserver connections (default is 9419)
      wait_for:
        port: 9419
    - name: Wait for chunkserver connections (default is 9420)
      wait_for:
        port: 9420
    - name: Wait for client (mount) connections (default is 9421)
      wait_for:
        port: 9421

    - name: Stat chunkserver directory /mnt/mfschunks1
      stat:
        path: /mnt/mfschunks1
      register: mfschunks1_dir
    - name: Check chunkserver directory /mnt/mfschunks1
      assert:
        that: mfschunks1_dir.stat.exists
    # # https://github.com/ansible/ansible/issues/66363
    # - name: show ansible_mounts
    #   debug:
    #     var: ansible_mounts
    - name: Get info {{ moosefs_mount }}
      command: df {{ moosefs_mount }}
      register: moosefs_df
      changed_when: false
    # - debug:
    #     var: moosefs_df
    - name: Check mountpoint {{ moosefs_mount }}
      assert:
        that:
          - moosefs_mount in moosefs_df.stdout
          - moosefs_df.stdout is search('mfsmaster:9421')
    - name: Stat file {{ moosefs_folders | first }}
      stat:
        path: "{{ moosefs_folders | first }}"
      register: moosefs_dir
    - name: Check {{ moosefs_folders | first }} directory
      assert:
        that: moosefs_dir.stat.exists
